;(function () {
    var oldStarcorExt = window.starcorExt || {};// {_setCallbackResult:function(){},_execAndroidFunc:function () {}};

    starcorExt = {
        _setCallbackResult: function (idx, ret) {

            oldStarcorExt._setCallbackResult(idx, ret);
        },
        _execAndroidFunc: function (func, args) {

            return oldStarcorExt._execAndroidFunc(func, args);
        }
    };

    starcorExt._invokeCallback = function (name, args, returnIdx) {
        var func = this._callbacks[name];
        var ret = null;
        //  console.log('===Args==='+JSON.stringify(args));
        try {
            var invokeArgs = [];
            for (var idx in args) {
                var item = args[idx];
                switch (item.type) {
                    case "number":
                        invokeArgs.push(Number(item.value));
                        break;
                    case "string":
                        invokeArgs.push(String(item.value));
                        break;
                    case "boolean":
                        //9998console.log('value = '+typeof item.value);
                        // invokeArgs.push("true".toLowerCase() == item.value);
                        invokeArgs.push(Boolean(item.value));
                        break;
                }
            }
            //     console.log('===invokeArgs==='+invokeArgs.join());
            ret = func.apply(this, invokeArgs);
        }
        catch (e) {
        }
        starcorExt._setCallbackResult(returnIdx, ret);
    };

    starcorExt._addCallback = function (callback) {
        var callbackIdx = String(starcorExt._callback_counter++);
        this._callbacks[callbackIdx] = callback;
        return callbackIdx;
    };
    starcorExt._callback_counter = 0;
    starcorExt._callbacks = {};
    // 调用浏览器功能，参数依cmd类型而定
    starcorExt.exec = function () {
        var args = [];
        for (var idx = 0; idx < arguments.length; ++idx) {
            var val = arguments[idx];
            switch (typeof val) {
                case "number":
                    args.push({
                        "type": "number",
                        "value": val
                    });
                    break;
                case "string":
                    args.push({
                        "type": "string",
                        "value": val
                    });
                    break;
                case "bool":
                    args.push({
                        "type": "boolean",
                        "value": val
                    });
                    break;
                case "object":
                    args.push({
                        "type": "object",
                        "value": val
                    });
                    break;
                case "function":
                    args.push({
                        "type": "callback",
                        "value": this._addCallback(val)
                    });
                    break;
            }
        }
        var cmd = args.shift();
        if (typeof this._execAndroidFunc === "undefined") {
            return null;
        }
        return this._execAndroidFunc(cmd.value, JSON.stringify(args));
    };
    // 读取系统属性
    // propName:
    //		user.name			读取用户名，未登录时值为空
    //		user.token			读取用户token，未登录时值为空
    //		user.id				读取用户id，未登录时值为空
    //		app.name			读取应用名
    //		app.version			读取应用版本
    starcorExt.readSystemProp = function (propName) {
        return String(this.exec("readSystemProp", propName));
    };
    starcorExt.closeBrwoser = function (reason) {
        if (reason) {
            return this.exec("closeBrowser", reason);
        }
    };
    // 返回服务器同步时间
    starcorExt.getServerTime = function () {
        return String(this.exec("getServerTime"));
    }
    // 返回token相关数据
    starcorExt.getTokenInfo = function () {
        return String(this.exec("getTokenInfo"));
    }
    // 返回N1下行接口数据
    starcorExt.getEpgInterfaceData = function () {
        return String(this.exec("getEpgInterfaceData"));
    }
    /* 获取基础信息接口
     *  @param methodname 方法名
     * */
    starcorExt.getBaseInfo = function (methodname) {
        return String(this.exec(methodname));
    }
    // 发送Android Intent
    // mode:
    //      sendBroadcast   发送广播
    //      startActivity   打开应用
    //      startService    启动服务
    starcorExt.sendIntent = function (mode, intent) {
        return this.exec("sendIntent", mode, intent);
    };
    // 设置事件回调
    // handlerType 回调类型, KeyEvent, Message
    // handler 回调函数, 其形式由handlerType决定
    //-----------------------------------------------------------------------------
    // handler为空表示取消对事件的监听
    // handler如果处理了事件, 返回true, 否则事件交由浏览器处理
    starcorExt.setHandler = function (handlerType, handler) {
        return this.exec("setHandler", handlerType, handler);
    };
    // 设置消息回调，handler形如function(msg, extInfo)
    // msg:
    //		onFocusChanged,	true/false	-	webview焦点变化，true表示获取焦点，false表示失去焦点
    starcorExt.setMessageHandler = function (handler) {
        return this.setHandler("Message", handler);
    };
    starcorExt.set_global_callback = function (name, callback) {
        //  console.log('===set_global_callback==='+name);
        this._callbacks[name] = callback;
    }
    //离开web页面
    starcorExt.onStop = function () {
        //   console.log('===onStop===');
        this._invokeCallback('page_event', [{
            "type": "number",
            "value": "1"
        }]);
    }
    //返回web页面，第一次打开页面不会触发
    starcorExt.onRestart = function () {
        //  console.log('===onRestart===');
        this._invokeCallback('page_event', [{
            "type": "number",
            "value": "2"
        }]);
    };

    starcorExt.on_user_change = function () {
        //  console.log('on_user_change call');
        this._invokeCallback('token_update', {});
    };
    // 获取焦点
    // webview获取焦点后，所有按键事件都将转发给页面处理
    starcorExt.requestFocus = function () {
        return this.exec("requestFocus");
    };
    // 设置按键事件回调, handler形如function(action, keyCode, keyName, metaState)
    // action可以为keyUp, keyDown
    // keyName为按键名称, 如: up, down, left, right, a, b, c, d, 1, 2, 3, 4, enter, return, UNKNOWN
    // keyCode为按键对应的键值
    // metaState为控制建对应状态，ctrl, alt, shift等
    starcorExt.setKeyEventHandler = function (handler) {
        return this.setHandler("KeyEvent", handler);
    };

    starcorExt.sendGet = function (url, headers, callback) {
        return this.exec("sendGet", url, headers, callback);
    };
    starcorExt.sendPost = function (url, body, headers, callback) {
        return this.exec("sendPost", url, body, headers, callback);
    };
    starcorExt.sendDownload = function (url, headers, callback) {
        return this.exec("sendDownload", url, headers, callback);
    };
    starcorExt.setStorageItem = function (space, key, item) {
        return this.exec("setStorageItem", space, key, item);
    };
    starcorExt.getStorageItem = function (space, key) {
        return this.exec("getStorageItem", space, key);
    };
    starcorExt.removeStorageItem = function (space, key) {
        return this.exec("removeStorageItem", space, key);
    };
    starcorExt.clearStorage = function (space) {
        return this.exec("clearStorage", space);
    };
    starcorExt.getServerUrl = function (apiId) {
        return this.exec("getServerUrl", apiId);
    };
    starcorExt.getWebPackage = function (packageId, callback) {
        return this.exec("getWebPackage", packageId, callback);
    };
    starcorExt.playVideo = function (mediaId) {
        return this.exec("playVideo", mediaId);
    };
    //  window.starcorExt = starcorExt;
    window.starcorExt = starcorExt;
})();